function AppTheme() {

}
/*******************************************************************************************
    Update the theme with the AppSkinInfo retrieved from the host product.
********************************************************************************************/
AppTheme.prototype.updateThemeWithAppSkinInfo = function (appSkinInfo) {
    var panelBackgroundColor = appSkinInfo.panelBackgroundColor.color;
    document.body.bgColor = this.toHex(panelBackgroundColor); // Need to check required or not
    var isPanelThemeLight = panelBackgroundColor.red > 127;
    if (isPanelThemeLight) {
        var isPanelThemeMediumLight = panelBackgroundColor.red < 213;
        if (isPanelThemeMediumLight) {
            $("#themeStyle").attr("href", "assets/css/mediumLight.css");
        } else {
            $("#themeStyle").attr("href", "assets/css/light.css");
        }
    } else {
        var isPanelThemeMediumDark = panelBackgroundColor.red > 52;
        if (isPanelThemeMediumDark) {
            $("#themeStyle").attr("href", "assets/css/mediumDark.css");
        } else {
            $("#themeStyle").attr("href", "assets/css/dark.css");
        }
    }
}

/*******************************************************************************************
    Method to convert color value into hexCode
********************************************************************************************/
AppTheme.prototype.toHex = function (color, delta) {
    function computeValue(value, delta) {
        var computedValue = !isNaN(delta) ? value + delta : value;
        if (computedValue < 0) {
            computedValue = 0;
        } else if (computedValue > 255) {
            computedValue = 255;
        }

        computedValue = computedValue.toString(16);
        return computedValue.length == 1 ? "0" + computedValue : computedValue;
    }

    var hex = "";
    if (color) {
        with (color) {
            hex = computeValue(red, delta) + computeValue(green, delta) + computeValue(blue, delta);
        };
    }
    return "#" + hex;
}