$._ext_PHXS = {   
    
    getXMPObj : function()
	{
		return new xmpModifier.GetXMP("http://ns.resourceSpace.ca/pcce", "pcce", app.activeDocument, app.activeDocument.activeLayer);
	},
	
    /*******************************************************************************************
    Method to show dialog to set iframe src and download path
    ********************************************************************************************/
    showUploadDialog: function()
    {
    	if(app.documents.length > 0)
    	{    
	        var w = new Window("dialog", "Upload");
	               
	        var grp1 = w.add("group")
	        var _url_label = grp1.add("statictext");              
	        _url_label.text = "Do you want to upload the current active document?";
	        
	        var grp2 = w.add("group")
	        grp2.alignment = "right";
	        var _ok_btn = grp2.add("button", undefined, "OK");
	        var _cancel_btn = grp2.add("button", undefined, "Cancel");
	        
	        with(w) { _cancel_btn.onClick = function() { close(null); } }
	        
	        if (w.show() == 1)
	        {
        		var docRef = app.activeDocument;
        		
        		var xmpObj =  $._ext_PHXS.getXMPObj();
    		
        		var data = new Object();
        		data.assetId = xmpObj.getStructField('damconnect_assetId');
        		data.assetName = xmpObj.getStructField('damconnect_assetName');	
        		data.assetData = ""; //xmpObj.getStructField('damconnect_metadata');   	   
        		data.assetVersion = xmpObj.getStructField('damconnect_versionId');  
        		data.assetDocumentPath = docRef.path + "/" + docRef.name; 
        		data.assetDocumentName = docRef.name;	        
	        
				return JSON.stringify(data);
	        }
        }
    },
    
    /*******************************************************************************************
    Method to open PhotoShop document
    ********************************************************************************************/
    openDocument: function(assetInfo)
    {
        try
	    {	    	
	        var fileRef = new File(assetInfo.path);
	        var docRef = app.open(fileRef);
	        
	        var xmpObj =  $._ext_PHXS.getXMPObj();
			
			xmpObj.setStructField('damconnect_assetName', assetInfo.assetName);
        	xmpObj.setStructField('damconnect_versionId', assetInfo.version);
        	xmpObj.setStructField('damconnect_assetId', assetInfo.assetId);
        	
        	docRef.save();
        
	        return 'opened successfully';
	    }
	    catch(ex)
	    {
	    	alert (ex.message);
	    }
	},
    
    /*******************************************************************************************
    Method to place any image asset file onto indesign document
    ********************************************************************************************/
    placeFile: function(filePath)
    {   
    	try
    	{ 
	    	if(app.documents.length == 0)
	        	app.documents.add();
	        		    	
	    	// place the file now to the created frame
	    	var idPlc = charIDToTypeID( "Plc " );
	    	var desc188 = new ActionDescriptor();
	    	var idIdnt = charIDToTypeID( "Idnt" );
	    	desc188.putInteger( idIdnt, 5 );
	    	var idnull = charIDToTypeID( "null" );
	    	desc188.putPath( idnull, new File(filePath) );
	    	var idLnkd = charIDToTypeID( "Lnkd" );
	    	desc188.putBoolean( idLnkd, true );
	    	var idFTcs = charIDToTypeID( "FTcs" );
	    	var idQCSt = charIDToTypeID( "QCSt" );
	    	var idQcsa = charIDToTypeID( "Qcsa" );
	    	desc188.putEnumerated( idFTcs, idQCSt, idQcsa );
	    	var idOfst = charIDToTypeID( "Ofst" );
	    	var desc189 = new ActionDescriptor();
	    	var idHrzn = charIDToTypeID( "Hrzn" );
	    	var idPxl = charIDToTypeID( "#Pxl" );
	    	desc189.putUnitDouble( idHrzn, idPxl, 0.000000 );
	    	var idVrtc = charIDToTypeID( "Vrtc" );
	    	var idPxl = charIDToTypeID( "#Pxl" );
	    	desc189.putUnitDouble( idVrtc, idPxl, 0.000000 );
	    	var idOfst = charIDToTypeID( "Ofst" );
	    	desc188.putObject( idOfst, idOfst, desc189 );
	    	executeAction( idPlc, desc188, DialogModes.NO);
	    	return "successfully placed";
    	}
    	catch(ex)
    	{
    		return ex.message;
    	}
	}
};