$._ext_common = {
   
	/*******************************************************************************************
    Method to show dialog to set iframe src and download path
    ********************************************************************************************/
    showSettingsDialog: function()
    {
    	var returnVal = { success : false };
    	var noSettings = true;
        var w = new Window("dialog", "Settings");        

        var prefObj = new Object();
        prefObj.url = "";
        prefObj.path = "";

        var prefsPath = Folder.userData + "/" + "damconnectPrefs.json";
        var prefsFile = new File(prefsPath);

        if (prefsFile.exists)
        {
            prefsFile.open("r");
            var content = prefsFile.read();
            if (content != '')
            {
                var jsonObj = JSON.parse(content);
                prefObj.url = jsonObj.url;
                prefObj.path = jsonObj.path;
                noSettings = false;
            }

            prefsFile.close();
        }

        var grp1 = w.add("group");
        var _url_label = grp1.add("statictext");
        var _url_edt = grp1.add("edittext");      
        
        var grp2 = w.add("group");
        grp2.alignment = "left";
        var _select_folder_btn = grp2.add("button", undefined, "Select Download Folder");
        var _download_path = grp2.add("edittext");
        _select_folder_btn.onClick = function()
        { //browse folder
            var outFile = Folder.selectDialog("Choose download folder location");
            _download_path.text = outFile.fsName;
        }
        
        var grp = w.add("group");
        grp.alignment = "right";
        var _ok_btn = grp.add("button", undefined, "OK");
        var _cancel_btn = grp.add("button", undefined, "Cancel");
        
        var grp3 = w.add("group");
		grp3.alignment = "left";

		var _versionlable = grp3.add("statictext");
		_versionlable.text = "v2019.08.08";

        _url_label.text = "Enter Server URL";
        _url_edt.characters = 40;
        _url_edt.text = prefObj.url.trim();
        _download_path.text = prefObj.path.trim();
        _download_path.characters = 40;
        _url_edt.active = true;

		with(w)
		{
			_cancel_btn.onClick = function()
			{			
				close(null);			
			}
		}
		
        if (w.show() == 1)
        {
            prefObj.url = _url_edt.text.trim();
            prefObj.path = _download_path.text.trim();

            var content = JSON.stringify(prefObj);

            prefsFile.open("w");
            prefsFile.writeln(content);
            prefsFile.close();
            returnVal.success = true;
            returnVal.data = prefObj;
            returnVal = JSON.stringify(returnVal);            
            return returnVal;
        }
    },

    /*******************************************************************************************
    Method to read setting file to get download path and iframe src.
    ********************************************************************************************/
    readSettings: function()
    {
        var prefsPath = Folder.userData + "/" + "damconnectPrefs.json";
        var prefsFile = new File(prefsPath);
        var content = '';
        if (prefsFile.exists)
        {
            prefsFile.open("r");
            content = prefsFile.read();
            prefsFile.close();
        }
        return content;
    },
    
    getActiveDocumentPath: function()
    {
    	var retVal = 
    	{
    		success : false,
    		data : ''
    	};
    	
    	try
		{
    		if(app.documents.length > 0)
        	{
    			var docRef = app.activeDocument;
    			
    			var file = File(docRef.fullName);
    			
    			var data =  {
					fileName : file.name, 
					filePath : file.fsName.toLowerCase().trim()
    			};
    			
    			retVal.data = data;
    			retVal.success = true;
    		}
        	else
        		retVal.data = "No document is active.";
		}
    	catch(ex)
    	{
    		retVal.data = ex.message;
    		if(ex.message.toLowerCase().indexOf("unsaved document") >=0)
    			retVal.data = "Please save the document before uploading";
    	}
    	finally
    	{
    		return JSON.stringify(retVal);
    	}    	
    },
    
    closeDocument: function()
    {    	
    	var retVal = { success : false }
    	if(app.documents.length <=0)
    	{
    		retVal.data = "No document is opened";
    		return JSON.stringify(retVal);
    	}    	
    	try
    	{
    		app.activeDocument.close();
    		retVal.success = true;
    	}
    	catch(ex)
    	{    		
    		retVal.data = ex.message;
    	}
    	finally
    	{
    		return JSON.stringify(retVal);    		
    	}
    }
};